﻿using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace GroupEditorPrototype
{
    public class GroupingItem : ViewModelBase
	{
		private string _name;
		public string Name
		{
			get => _name;
			set => SetProperty(ref _name, value);
		}

		private string _parentGroup;
		public string ParentGroup
		{
			get => _parentGroup;
			set => SetProperty(ref _parentGroup, value);
		}

		private bool _isExpanded;
		public bool IsExpanded
		{
			get => _isExpanded;
			set => SetProperty(ref _isExpanded, value);
		}		

        private List<GroupingItem> _nodes;
		public List<GroupingItem> Nodes
		{
			get => _nodes;
			set => SetProperty(ref _nodes, value);
		}
	}

	public class Schema : ViewModelBase
    {
		private ObservableCollection<Group> _children = new ObservableCollection<Group>();
		public ObservableCollection<Group> Children
		{
			get => _children;
			set => SetProperty(ref _children, value);
		}

		private string _name;
		public string Name
		{
			get => _name;
			set => SetProperty(ref _name, value);
		}

		private bool _isExpanded;
		public bool IsExpanded
		{
			get => _isExpanded;
			set => SetProperty(ref _isExpanded, value);
		}
	}

	public class Group : GroupingItem
    {
		private ObservableCollection<GroupingItem> _children = new ObservableCollection<GroupingItem>();
		public ObservableCollection<GroupingItem> Children
		{
			get => _children;
			set => SetProperty(ref _children, value);
		}
	}

	public class SchemaNode : GroupingItem
	{

    }

	public class AssetNode : GroupingItem
	{
		private ObservableCollection<GroupingItem> _children = new ObservableCollection<GroupingItem>();
		public ObservableCollection<GroupingItem> Children
		{
			get => _children;
			set => SetProperty(ref _children, value);
		}
	}

	public class Device : GroupingItem
	{

    }
}
